Ext.namespace('dSA', 'dSA.actions', 'dSA.util', 'dSA.dialogs',
              'dSA.actions.areaconfig');

dSA.actions.areaconfig.UpdateProgress = function(task_id, p, store)
{
    if (dSA.actions.areaconfig.TaskID === 0)
    {
        if (dSA.actions.areaconfig.UIReloaded === false) {
            dSA.actions.areaconfig.UIReloaded = true;
            dSA.util.reloaddSSUI();
        }
        return;
    }

    dSA.functions.GetTaskStatus(
        task_id,
        function(success, data)
        {
            if (success === false)
            {
                p.getDialog().setIconClass('dSA_ReadAreaConfigTitle');
                p.hide();
                dSA.actions.areaconfig.TaskID = 0;
                return;
            }

            dSA.actions.areaconfig.TaskID = data.id;
            if ((data.id == 0) ||
                (data.status === 'finished') ||
                (data.status === 'cancelled'))
            {
				p.updateProgress(1, '100%');
                p.getDialog().setIconClass('dSA_ReadAreaConfigTitle');
                p.hide.defer(2000, p);

                dSA.functions.LoadAreaConfigurationData(task_id,
                    function(success, data) {
                        if (!success) {
                            return;
                        }
        
                        if ((dSS.module === true) &&
                            (data.devices.length > 0)) {
                            dSS.MessageBus.fireEvent('updateareadata',
                                                     data.devices);

                        }
                    });
                return;
            } 

            p.updateProgress(data.progress * 0.01,
                             data.progress + '%');

            dSA.actions.areaconfig.UpdateProgress.defer(2000, this, [task_id, p,
                                                        store]);
        }
    );
};

dSA.actions.areaconfig.ReadData = function(zone, group, store)
{
    dSA.actions.areaconfig.TaskID = 0;
    dSA.actions.areaconfig.UIReloaded = false;

    dSA.functions.ReadAreaConfiguration(zone, group, store,
        function(success, task_id, store)
        {
            if (success !== true)
            {
                return;
            }
            
            dSA.actions.areaconfig.TaskID = task_id;

            var p = Ext.MessageBox.show({
                title: dSA._("Reading configuration") + '...',
                msg: dSA._("Reading device area configuration"), 
                iconCls: 'loading-indicator-small',
                progressText: '0%',
                width: 400,
                progress: true,
                buttons: { cancel: true },
                fn: function() 
                { 
                    dSA.functions.AbortTask(task_id);
                    dSA.actions.areaconfig.TaskID = 0;
                    p.getDialog().setIconClass('dSA_DeviceAreaConfigTitle');
                    p.hide();
                },
                closable:false
            }); 

            dSA.actions.areaconfig.UpdateProgress(task_id, p, store);
        }
    );
};
